#include <stdio.h>
#include <string.h>
#include "query.h"
char board[1100][1100];
char io,co;
int rows,cols,ir,ic,cor,coc;

//unsigned _stklen = 10000000;

//I have compiled and tested this program as C and C++

void right_o() {
    int temp = cor;
    cor = coc;
    coc = -temp;
}
void visit(int cr, int cc) {
    int i,j,k,result;
    if(cr<0 || cr>=rows || cc<0 || cc>=cols) return;
    if(board[cr][cc]!='\?') return;
    result = Forward();
    if(result==0) {
        board[cr][cc] = 'X';
        return;
    } else {
        board[cr][cc] = '.';
        visit(cr+cor,cc+coc);
        Left(); right_o(); right_o(); right_o();
        visit(cr+cor,cc+coc);
        Right(); Right(); right_o(); right_o();
        visit(cr+cor,cc+coc);
        Right(); Forward(); Right(); Right();
        right_o(); right_o(); right_o();
    }
}
    
main() {
    int i,j;
    freopen("bluff.in","r",stdin);
    freopen("bluff.out","w",stdout);

    scanf("%d %d %d %d %c ",&rows,&cols,&ir,&ic,&io);
    ir--; ic--;
    cor=coc=0;
    memset(board,0,sizeof board);
    for(i=0;i<rows;i++) for(j=0;j<cols;j++) board[i][j]='\?';
    board[ir][ic]='.';
    switch(io) {
       case 'N': cor=-1; break;
       case 'S': cor=1 ; break;
       case 'E': coc=1;  break;
       case 'W': coc=-1; break;
       default: printf("unrecognized orientation: %c\n",io); return 1;
    }
    visit(ir+cor,ic+coc);
    Right(); right_o();
    visit(ir+cor,ic+coc);
    Right(); right_o();
    visit(ir+cor,ic+coc);
    Right(); right_o();
    visit(ir+cor,ic+coc);

    for(i=0;i<rows;i++) printf("%s\n",board[i]);

}

    
