#include <stdio.h>
#include <map>
#include <string.h>
#include <string>
#include <math.h>

map<string,int> m,spam,non;
char buf[1000], tri[4];

double sim(map<string,int> f1, map<string,int> f2) {
   double dot = 0, s1 = 0, s2 = 0;

   for (map<string,int>::iterator p = f1.begin(); p != f1.end(); *p++) {
      dot += p->second * f2[p->first];
   }

   for (map<string,int>::iterator p = f1.begin(); p != f1.end(); *p++) {
      s1 += p->second * p->second;
   }

   for (map<string,int>::iterator p = f2.begin(); p != f2.end(); *p++) {
      s2 += p->second * p->second;
//if(debug && p->second) printf("%s %d\n",(p->first).c_str(),p->second);
   }

	 //printf("dot: %.5lf\ns1: %.5lf\ns2: %.5lf\n",dot,s1,s2);
   return dot / sqrt(s1 * s2);
}

main(){
   int i, j, n1, n2, n3;
   scanf("%d%d%d",&n1,&n2,&n3);
   while (gets(buf)) {
      if (!strcmp(buf,"ENDMESSAGE")) {
         if (!n2) {
            double simspam,simnon;
						simspam = sim(m,spam);
						simnon = sim(m,non);
						printf("%0.5lf %0.5lf\n",simspam,simnon);
            if (simspam > simnon) printf("spam\n");
            else printf("non-spam\n");
            m.clear();
         }
         if (n1) n1--;
         else if (n2) n2--;
         else if (n3) n3--;
      } else { //ENDMESSAGE is not part of the message
      j = strlen(buf)-2;
      for (i=0;i<j;i++){
         strncpy(tri,buf+i,3);
				 //printf("trigram %s\n",tri);
         if (n1) spam[tri]++;
         else if (n2) non[tri]++;
         else if (n3) m[tri]++;
      }
			}
   }
}
